Schoonschip conventions.

 Old			New		Old	Operator	New
octal			hex		octal			hex
   0	dummy		  0		1401	dummy key	301
 400	index		100		1402	superkey	302
1000	vector		200		1403	p(#)		303
1400	operator	300		1404	<***> (Compo)	304
2000	symbol		400		1405
2400	expr.	char.	500		1406
3000	function	600		1407	- sign
3400	number		700		1410	Conjg()
4000	vect. nr.	800 (see below)	1411	-Conjg()
			B00		1412	Integ()
6000	dotprod.	C00-D00		1413	-Integ()
	free		E00		1414	Table		305
        free		F00		1415	-Table
Function name as function		1416	end Table	306
argument: subtract 0x3E0,		1417	Key request	307
i.e. 0x220 + funct nr.			1420	Conjg		308
					1421	end Conjg	309
The remaining 4 leading bits		1422	Reduce		30A
are used as follows:			1423	Trace		30B
					1424	Pass		30C
 Iep use, free, sign, expr.		1425	Error		30D
bit  7      6     5     4		1426	Character
    15     14    13    12			Condition codes 30E
						Clear Flag	30F
 If the expr bit set (bit 4)			Set Flag	310
then the other header bits			Change Flag	311
imply:						Test Flag	312
						Take next if <0,
						else one after.
						4 dim index	313
						n-4 dim index	314

    Sign, set, set if X-D-T-F, set if Integ, set if Conjg, set if abs addr.
bit   5    4        3			 2		1		0
     13   12	   11			10		9		8

If bit 3 set (X etc) then bit 0 is part of the entry number to provide for
511 entries.
Bit 3 is not set for an expression in brackets, and bit 0 is used to indicate
whether the address is given through a Loc nr (bit 0 not set) or as an
absolute address in It. In the latter case this header is followed by the
24 bit address, either in the form  ** 05** 05** (in It) or ****** (this
happens in Hugo.a and Number.a in argument lists for numerical evaluation).
   Expression thus read as 0x1000 or 0x1100, X-F as 0x1800 and Tables as
0x1900. Sign is 0x2000, Integ 400 and Conjg 200.

Concerning vectornr, dotpr.
Since vector 0 cannot occur the patterns 0x800 - 0x81F are free.
From these 0x800 and 0x801 are used for * and / as function arg.
Actually vector 1 is a reserved quantity and cannot occur. Including
that thus free up to 0x83F.
Dotproducts have two vectors and are symmetric between the two.
The convention is that the upper 5 bits hold the smallest. Then in fact
only 496 different patterns can occur: 1 with 1-31, 2 with 2-31 etc.
Making a cross-reference table one may achieve that only 9 bits are
needed; then the patterns 0xE** and 0xF** are free.

-------------------------------------------------------------------------
Format X, D and DS functions as occurring in a term:
	X  0x60A 0800 18** .... 600	**=entry in Nxgeh.
	D  0x60A 0200 18** .... 600
Ds as corresponging to Ds(J1,1,3,(),()):
	Ds 0x613 7** dum1 dum2 .... 780 1 3 expr1 expr2 600
where ** is the number of dummies following. The 780 is a location reserved
for dummy J1, going to take the values 701, 702 and 703.

Format D expression as stored in memory:
	2 number expr	   2 number expr  ....	1 number expr
'expr' is the expression symbol and exponent, thus occupying 2 words.

-------------------------------------------------------------------------
Condition codes. Variable Ccode (word for A and B) in Exec, to be set in
Hugo.a. Two sense switches, A and B, may be on/off. Any substitution may
be preceeded by a sequence of instructions, contained in two bytes. The
first 4 bits contain type one, the next four type two and the remaining eight
type three.


 First type	Second type			Third type
 Ifs/Ifc(x)	Ifn(Y/N K/D Set/Clr/Chg A/B)	Ify(Y/N K/D Set/Clr/Chg A/B)

 x may be A, B, A&B, A ! B.

Code first type: 4 bits.
 First two bits:			Next two bits:
			00 Do always			00 A
		  Ifs	01 Do if x Set			01 B
		  Ifc	10 Do if x Clr			10 A&B
							11 A!B

Code second type: 4 bits. Associated K/D in third type, see below.
 First two bits:			Next two bits:
			00 Do nothing			00 Do nothing
			11 Set A			11 Set B
			10 Clr A			10 Clr B
			01 Chg A			01 Chg B

Code third type: 8 bits.
 First bit: 0=Y, 1=N 	(applies to Ify only).
 Next bit: Ifn 0/1=K/D
 Next bit: Ify 0/1=K/D
 Next two bits:				Last two bits:
		00 Do nothing				00 Do nothing
		11 Set A				11 Set B
		10 Clr A				10 Clr B
		01 Chg A				01 Chg B

Keywords: Ifs, Ifc, Ifn, Ify, Set, Clr, Chg, D, N.


------------------------------------------------------------------------------
Nageh

 Name (6 bytes), dummy nr (2 bytes),

 +8 76543210	+9 ........
 7 Zeroing	Reality prop.
 6 Outp pres.
 5-0 Signed
     zero nr
------------------------------------------------------------------------------
Nfgeh

 Name (6 bytes), dummy nr (2 bytes),

 +8 .6......	+9 ........
 6 Outp pres.	Reality prop.
------------------------------------------------------------------------------
Nvgeh

 Name (6 bytes, only two used), dummy nr (2 bytes),

 +8 76......
 7 Zeroing
 6 Outp pres.
------------------------------------------------------------------------------
Nvigeh

 Name (6 bytes), dummy nr (2 bytes),

 +8 765.....	+9 7.......
 7 Created ind	7 Symb/nr 1/0
 6 Outp pres.	6-0 Dimension
 5 C-flag, in
   Helene.a.
------------------------------------------------------------------------------
Nxgeh

 Name (6 bytes)

 +6 ........	+7 7.......	+8 76543210	+9 ........ +10 +11

 X-expr: byte +6 Level depth,	7 File/X,D 1/0	Loc nr. or address in mem
 byte +7 bit 7: Table/X,D 1/0	6 Comm/loc 1/0  if X/D/T-expression
 bits 5,6:			5 Freez/nF 1/0
 00: Table (2 bytes/entry)	4
 10: String table		3 Keep/del 1/0
 11: Short table (1 byte/entry)	2 Punch/no 1/0
 01: Not used			1 Print/no 1/0
				0 X,D or
				no-ind/ind 1/0
The entries in a string table are zero terminated strings, one after the other.
Two zeroes terminate the entries.
The short table is for characters. For a character of the form 0x5nn first
bring nn into the natural form with the macro Natur (rolb #1, possibly followed
by bchg #0) then subtract 0x40. This gives 192 entries. i.e. 192 bytes.

 For file: bytes +6 and +7
 contain index/nr of frozen
 subfiles.
------------------------------------------------------------------------------

Input array's.

Loc: 12 bytes/entry.

	The info bits of byte +4 are:
		1/0 for common/local	(bit 7)
		1/0 for file/no file	(bit 6)
		1/0 for not/in memory	(bit 5).
		1/0 for numerical/non-numerical (bit 4).

Expression: address dummy key (4), info bits (1), 0 (1),
		number of dummies (2), address in It (4 bytes).
	If the number of dummies is zero this means that the dummy list
	is terminated by a long 0. Info bits: 0000.

Numerical file: 0 (4), info (1), 0 (1), exponent (2), fract (4).
		Info bits: *101

File in memory: address filename and namelist (4), info (1),
		filelength > 13 (3), address first word of file (4).
		Info bits: 010*

File on tape: address dummy key (4), info (1), #  of records (3),
		first record number.
		Info bits: *110

-------------------------------------------------------------------------

Idgeh: Pilot word of 8 bytes followed by identifier.

	Pilot word: first level (1), last level (1), expr # (1),
			kind (1), reserve (2), loc next in Idgeh (2).
	Identifier: 4 bytes/symbol, right adjusted.

Ipr: Z-expression information, 4 bytes/Z-expression.
		Loc number (2), location filename and arg in Filnam (2).

Filnam: Filenames, 10 bytes in same format as in Nxgeh, followed
		by the arguments (2 bytes/argument).

Exec array's.

Iscal:	4 bytes/entry  Symbol (2), exponent possibly with head (2)
Ipr1:	1 byte/entry = exponent.
Ipr:	2 bytes/entry. Contain -1 (function occurrence), 0 or symbol (index,
	vector, number).
Iep:	4 bytes/entry. May contain one or two symbols (right byte = first
	symbol), or else, with non-zero first byte:
	If first bit set (bit 31) and the second is zero then this specifies
	a jump (after taking out the possible symbol in the last 2 bytes).
	Further:
	 0xE0, expr nr, 0, multiplicity
	 0xEn, It address (3 bytes, see note)	n = multiplicity,  0<n<7.
	 0xE7, 0, 0, multiplicity followed by long word containing
	 0xE7, It address (3 bytes, see note).
	 0xEF,0, symbol (2 bytes) as old -1, jmp back.
	 0xEE,0, symbol (2 bytes) as old -2, skip forward.
	 0xFF,0,0,0 No content, but space reservation for packiep.
Note: It address is relative to contents Memstart. Negative address
 (i.e. negative when sign of the third byte extended) implies - offset
 relative to Itbase.
Variable Keypres: 0 = no dummies; >0 = nr of dummies; <0 = - nr of dummies,
 address in Keyd.

-------------------------------------------------------------------------
Tape formats.

Yep tape. Every vector is preceeded by 0 (2 bytes).
	Record terminated by 1 (2 bytes) if record following,
	File terminated by 3 (2 bytes).
  Structure vector part: 0 or 5 (2), length (2), 0x8000+loc in Filnam (2),
		vector part, no numerical coefficient, terminated by 0 (2).
  Structure algebra part: length (2), expon (2), fraction (12/4/0),
		Note: length >= 4.
  The numerical coefficient has bit 15 of the exponent part set if only
  4 byte fraction. Bit 14 set if word size number.
In every record the current vector is reproduced in front. In that case
 the preceeding word contains 5 rather then 0.
 Storage dump files have the same format except the terminating zeroes
 are missing, and the vector part is not reproduced.

Common files. The first record contains names (10 bytes/name) with
	the symbol for the name following the 6 byte name. The
	symbol is the code from the problem that created the file.
	The further structure is as for the Yep tape, except
	the 0x8000 word in the vector is absent, and algebra part
	has terminating zero.

	The file names on a common tape are:
	Name(6 bytes), various (as in Nxgeh, 4 bytes),
	various (as in Loc, last 8 bytes).

Namelist: 10 bytes/entry. First entry: name of the file. Get in just as
	in Nxgeh, except last 8 bits now contain nr of arguments (not
	nr of dummies, which will be much larger for common files).
	Next names as in the name tables, with in bytes +6 and +7 the
	code as in the problem where the file was created. The record
	is terminated by a word containing 1.

Note: The minimum tape file, only one number, is:
	0(2),4(2),0(2),18(2),exp(2),fract(12),0(2),3(2 bytes).
      The minimum length of a file in memory is thus 26 bytes, except
      if four (zero) byte fraction; then minimum is 18 (14) bytes.

-------------------------------------------------------------------------
Trace equations ptrick:
 /p S /p = - p^2 Sr + 1/2 /p(/p Sr) +1/2 /p G5 (G5 /p Sr)	odd  S.
 /p S /p = - p^2 Sr + 1/2 Ga /p (/p Ga Sr)			even S.

These are worked out using the read elsewhere device. Let A /p S /p C
occur. Then first copy A and C, and the reverse of S into It at the
addresses:
	a1: A	a2: Sr	a3: C
Then create the correct expression. For S odd:
 44,-1.,D(p,p) read(a1) read(a2) read(a3) 0
 50,+0.5, read(a1) /p read(a3) G(L,T,Gi,p,read(a2)) 0
 0,+0.5, read (a1), /p G5 read(a3) G(L,T,G5,p,read(a2)) 0
For even strings the first term is the same, but the second becomes:
 0,+0.5, read(a1) a /p read(a3) G(L,T,Gi,p,a,read(a2)) 0
where a is a created index.
